C..............................................................................
C
C Global parameter(s):
C
C nreac       == maximal amount of chemical reactions to be read,
C
C nspec       == maximal amount of chemical species to be considered,
C
C nspec2      == maximal amount of initially present chemical species,
C
C ntime       == maximal amount of taken time steps,
C
C nss         == x nspec = amount of non-zero Jacobian elements
C 
C..............................................................................
C
C Common block(s):
C
C..............................................................................
C
C BL1:
C
C ns           == amount of species,
C
C s(ns)        == a species set,
C
C nr           == amount of reactions in the input file,
C
C index(nr)    == indices of the corresponding chemical reactions,
C
C r1(nr)       == names of the first reactants,
C
C ir1(nr)      == array of indices of 'r1' species in extended species set 's',
C
C r2(nr)       == names of the second reactants,
C
C ir2(nr)      == array of indices of 'r2' species in extended species set 's',
C
C p1(nr)       == names of the first products, 
C
C ip1(nr)      == array of indices of 'p1' species in extended species set 's',
C
C p2(nr)       == names of the second products, 
C
C ip2(nr)      == array of indices of 'p2' species in extended species set 's',
C
C p3(nr)       == names of the third products, 
C
C ip3(nr)      == array of indices of 'p3' species in extended species set 's',
C
C p4(nr)       == names of the fourth products, 
C
C ip4(nr)      == array of indices of 'p4' species in extended species set 's',
C
C p5(nr)       == names of the fifth products, 
C
C ip5(nr)      == array of indices of 'p5' species in extended species set 's',
C
C alpha(nr)    == first components of the rate coeffs.,
C
C beta(nr)     == second components of the rate coeffs.,
C
C gamma(nr)    == third components of the rate coeffs.,
C
C alpha_is(nr) == first components of the rate coeffs. for the ISRF,
C
C beta_is(nr)  == second components of the rate coeffs. for the ISRF,
C
C gamma_is(nr) == third components of the rate coeffs. for the ISRF,
C
C ak(nr)       == rate coefficients, computed from 'alpha', 'beta' and 'gamma',
C
C Rdiff,       == diffusion, accretion, and desorption rates for surface species
C Racc,
C Rdes
C
C iar, idr     == corresponding indices,
C
C ddens        == number density of small grains,
C
C irac         == returns an index of a gas-phase analoug to a surface species,
C
C ion_reac     == 0/1 flag denoting photoionization reaction,
C
C UV_field     == a string constant defining incident UV RF
C
C..............................................................................
C Global parameter(s):

      INTEGER nreac, nspec, nspec2, ntime, nss
      PARAMETER (nreac=9500,nspec=900,nspec2=900,ntime=999,nss=nspec*5)

C Common block (rates, abundances, etc.):
      INTEGER ns, nre, index, ir1, ir2, ip1, ip2, ip3, ip4, igH, igH2,
     1  ip5, nJ, iar1, iar2, idr1, idr2, jar1, jar2, irac1, irac2, iHY,
     2  ion_reac, rtype

      REAL*8 alpha, beta, gamma, alpha_is, beta_is, gamma_is, ak, times, 
     1  gdens, ddens, Rdiff0, Rdiff1, Racc, Rdes, ak_dens, stoch_lim, 
     2  Sads

      CHARACTER*4 surf_method
      CHARACTER*8 s, r1, r2, p1, p2, p3, p4, p5   

      DIMENSION s(nspec), r1(nreac), r2(nreac), p1(nreac), p2(nreac), 
     1  p3(nreac), p4(nreac), index(nreac), alpha(nreac), beta(nreac), 
     2  gamma(nreac), ir1(nreac), ir2(nreac), ip1(nreac), ip2(nreac), 
     3  ip3(nreac), ip4(nreac), times(ntime), ak(nreac), Rdiff0(nreac),
     4  Rdiff1(nreac), Racc(nreac), Rdes(nreac), ak_dens(nreac),
     5  iar1(nreac), iar2(nreac), idr1(nreac), idr2(nreac), jar1(nreac), 
     6  jar2(nreac), ip5(nreac), p5(nreac), irac1(nreac), irac2(nreac),
     7  iHY(nreac), ion_reac(nreac), alpha_is(nreac), beta_is(nreac), 
     8  gamma_is(nreac), rtype(nreac)      


      COMMON /BL1/ ns, s, nre, index, ir1, ir2, ip1, ip2, ip3, ip4, 
     1  ip5, iar1, iar2, jar1, jar2, idr1, idr2, irac1, irac2, rtype, 
     2  iHY, ion_reac, igH, igH2, r1, r2, 
     3  p1, p2, p3, p4, p5, alpha, beta, gamma, alpha_is, beta_is, 
     4  gamma_is, ak, Rdiff0, Rdiff1, Racc, Rdes, ak_dens, times,
     5  gdens, nJ, surf_method, ddens, stoch_lim, Sads


