      subroutine Jacobian(F,n,t,y,ysv,rewt,fty,V,hrl1,JacS,IWP,IER,
     1     RPAR, IPAR)
      implicit none


c Global variable:
      integer n, IPAR, IWP, IER
      real*8 y, ysv, t, RPAR, rewt, fty, v, hrl1, JacS
      dimension y(*), IPAR(*), RPAR(*), ysv(*), rewt(*), fty(*), 
     1   V(*), JacS(*), IWP(*)

C Common blocks:
      INCLUDE "Fcn.h"
	
C Local variables:
      character*2 suf
	integer i,j,k,jr1, jr2, jp1, jp2, jp3, jp4, jp5, l, m, 
     1    icc, ir, ic0, IWP0, iter, kk, nJ0, jpvt
	real*8 term1, term2, U, Jac, hrl_s
	DIMENSION Jac(nspec,nspec),jpvt(8*nspec),
     1  ir(nspec*nss),icc(nspec*nss),ic0(nspec*nss),IWP0(5*nspec)

C External function:
      EXTERNAL F

C Save information:
      SAVE nJ0, IWP0, icc, hrl_s

C Construct JAC "on the fly":
      kk = 0

C Initialization:
	DO j = 1, ns
        DO k = 1, ns
          Jac(j,k) = 0.0d0
	  ENDDO
	ENDDO

C Loop by reactions:
      DO j = 1, nre
	  jr1 = ir1(j)
	  jr2 = ir2(j)
	  jp1 = ip1(j)
	  jp2 = ip2(j)
	  jp3 = ip3(j)
	  jp4 = ip4(j)
	  jp5 = ip5(j)	  

C No second reactant:
        IF (jr2.EQ.0) THEN
	    term1 = ak(j)
	    Jac(jr1,jr1) = Jac(jr1,jr1) - term1
	    Jac(jp1,jr1) = Jac(jp1,jr1) + term1
	    if (jp2.ne.0) Jac(jp2,jr1) = Jac(jp2,jr1) + term1
	    if (jp3.ne.0) Jac(jp3,jr1) = Jac(jp3,jr1) + term1
	    if (jp4.ne.0) Jac(jp4,jr1) = Jac(jp4,jr1) + term1
	    if (jp5.ne.0) Jac(jp5,jr1) = Jac(jp5,jr1) + term1	    
	  ELSE
C Reactions with second reactant:
          term1 = ak(j)*y(jr1)
          term2 = ak(j)*y(jr2) 
          Jac(jr1,jr1) = Jac(jr1,jr1) - term2
          Jac(jr1,jr2) = Jac(jr1,jr2) - term1
	    Jac(jr2,jr1) = Jac(jr2,jr1) - term2
          Jac(jr2,jr2) = Jac(jr2,jr2) - term1
	    Jac(jp1,jr1) = Jac(jp1,jr1) + term2
          Jac(jp1,jr2) = Jac(jp1,jr2) + term1
	    if (jp2.ne.0) Jac(jp2,jr1) = Jac(jp2,jr1) + term2
          if (jp2.ne.0) Jac(jp2,jr2) = Jac(jp2,jr2) + term1
	    if (jp3.ne.0) Jac(jp3,jr1) = Jac(jp3,jr1) + term2
          if (jp3.ne.0) Jac(jp3,jr2) = Jac(jp3,jr2) + term1
	    if (jp4.ne.0) Jac(jp4,jr1) = Jac(jp4,jr1) + term2
          if (jp4.ne.0) Jac(jp4,jr2) = Jac(jp4,jr2) + term1
	    if (jp5.ne.0) Jac(jp5,jr1) = Jac(jp5,jr1) + term2
          if (jp5.ne.0) Jac(jp5,jr2) = Jac(jp5,jr2) + term1          
	  END IF

C End loop by reactions:
      END DO

cd      term1 = ak_dH2*gdens
cd      Jac(iH,iH) = Jac(iH,iH) - 2.0d0*term1
cd	Jac(iH2,iH) = Jac(iH2,iH) + term1	

C Transform to the form I - Jac*hrl1 and initialize non-zero elements:
	DO j = 1, ns
	  DO k = 1, ns	
	    Jac(j,k)= -hrl1*Jac(j,k)
          if (k.eq.j) Jac(j,j) = Jac(j,j) + 1.0d0	    	   	     
	    if (Jac(j,k).ne.0.0d0) then
	      kk = kk + 1
	      JacS(kk)= Jac(j,k) 
            ir(kk)  = j
            IPAR(kk)  = k
	    endif
	  ENDDO
	ENDDO

	nJ = kk
	iter = iter + 1

C Jacobian is changed in comparison with that one from the previous call: 
	IF ((nJ.ne.nJ0).or.(hrl1.lt.hrl_s)) THEN
c	IF (nJ.ne.nJ0) THEN

	  nJ0 = nJ

C Factorize the matrix:
	  U = 1.0d0
       
	  call MA28AD(n,nJ,JacS,nJ*5,ir,nJ*3,IPAR,U,IWP,jpvt,RPAR,IER)

	  do i = 1, 5*n
	    IWP0(i) = IWP(i)
	  enddo
	  do i = 1, nJ*5
	    icc(i) = IPAR(i)
	  enddo

        suf='AD'

C Use the same pivot order as from the last call to MA28AD:
      ELSE

	  do i = 1, 5*n
          IWP(i) = IWP0(i)
	  enddo
	  do i = 1, nJ*3
	    ic0(i) = IPAR(i)
	  enddo
	  do i = 1, nJ*5
	    IPAR(i) = icc(i)
	  enddo

        CALL MA28BD(n,nJ,JacS,nJ*5,ir,ic0,IPAR,IWP,jpvt,RPAR,IER)
 
        suf='BD'

	ENDIF

	  hrl_s = hrl1

cd       write (*,100), iter, t, hrl1, nJ, suf
100   format (1X,i7,2(1X,1pE13.6),1X,i8,1x,a2)


      return
      end 
C
C Solution of the system Ax=b:
C
      SUBROUTINE PSOL(N, T, Y, FTY, WK, HRL1, WP, IWP, V, LR, IER,
     1                  RPAR, IPAR)

C Global parameters:
      INTEGER IWP, IER, IPAR, N, LR
      DOUBLE PRECISION T, Y, FTY, WK, HRL1, WP, V, RPAR
      DIMENSION Y(*), FTY(*), WK(*), WP(*), IWP(*), V(*), 
     1	RPAR(*), IPAR(*)

C Common blocks:
      INCLUDE "Fcn.h"

C Direct solution of the system Ax=b:
	CALL MA28CD(n,WP,nJ*5,IPAR,IWP,V,RPAR,1)

      IER = 0

      RETURN
      END 